import 'package:flutter/material.dart';
import 'package:photo/src/delegate/badge_delegate.dart';
import 'package:photo/src/delegate/checkbox_builder_delegate.dart';
import 'package:photo/src/delegate/loading_delegate.dart';
import 'package:photo/src/delegate/sort_delegate.dart';
import 'package:photo/src/entity/_theme.dart';
import 'package:photo_manager/photo_manager.dart';

class Options {
  final int rowCount;

  final int maxSelected;

  final double padding;

  final double itemRadio;

  final PhotoTheme theme;

  final int thumbSize;

  final SortDelegate sortDelegate;

  final CheckBoxBuilderDelegate checkBoxBuilderDelegate;

  final LoadingDelegate loadingDelegate;

  final BadgeDelegate badgeDelegate;

  final PickType pickType;

  const Options({
    this.rowCount,
    this.maxSelected,
    this.padding,
    this.itemRadio,
    this.theme,
    this.thumbSize,
    this.sortDelegate,
    this.checkBoxBuilderDelegate,
    this.loadingDelegate,
    this.badgeDelegate,
    this.pickType,
  });
}

class ListOptions extends Options {

  final Axis scrollDirection;

  const ListOptions({
    this.scrollDirection = Axis.horizontal,
    double itemRadio,
    int maxSelected,
    double padding,
    PhotoTheme theme,
    int thumbSize,
    SortDelegate sortDelegate,
    CheckBoxBuilderDelegate checkBoxBuilderDelegate,
    LoadingDelegate loadingDelegate,
    BadgeDelegate badgeDelegate,
    PickType pickType,
  }) : super(
    maxSelected: maxSelected,
    padding: padding,
    itemRadio: itemRadio,
    theme: theme,
    thumbSize: thumbSize,
    sortDelegate: sortDelegate,
    checkBoxBuilderDelegate: checkBoxBuilderDelegate,
    loadingDelegate: loadingDelegate,
    badgeDelegate: badgeDelegate,
    pickType: pickType,
  );
}

enum PickType {
  all,
  onlyImage,
  onlyVideo,
}

class PickedEntity {
  const PickedEntity({List<AssetEntity> asset, this.isFullImage = false}) : asset = asset ?? const[];
  final List<AssetEntity> asset;
  final bool isFullImage;
}